#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

#include <QToolButton>
#include <QTreeWidgetItem>
#include <QTableWidgetItem>

#include <QGraphicsScene>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    static MainWindow * instance;
    void updateTree ();

private slots:
    // void on_actionOpen_triggered();
    // void on_actionSave_triggered();
    void on_actionQuit_triggered();

    // void on_actionCopy_triggered();
    // void on_actionPaste_triggered();

    void scene_selection_changed ();

    void on_tree_itemDoubleClicked(QTreeWidgetItem *item, int column);

private:
    Ui::MainWindow * ui;

    QGraphicsScene * scene;
    QGraphicsItem * current_item;

    void updateBranch (QTreeWidgetItem *branch, QGraphicsItem *item);

    void addLine(QString name, QVariant value);
    void updateTable (QGraphicsItem * item);
};

void refreshTree ();

class TreeItem : public QTreeWidgetItem
{
public:
    QGraphicsItem * shape;
};

#endif // MAINWINDOW_H
